-- reporter: make sure the whole guild knows of your success and shame
-- Original idea by Harpo
-- modified heavily & redesigned by Estrian
-- v1.3b @ 6th August 2013

declare('reporter', {})

reporter.NoArgs={}
reporter.toggle={}
reporter.Init={}
reporter.someDeath={}
reporter.GroupEvents={}
reporter.GroupModeToggle={}
reporter.ArgToggle={}

function reporter.NoArgs()
	print('Commands are /reporter toggle/on/off/group')
end
	

function reporter.ArgToggle()
	if pluginState == 1 then
		pluginState = 0
		print('reporter toggled, OFF')
	else 
		pluginState = 1
		print('reporter toggled, ON')
	end
end

function reporter.toggle(data,args)
	if not args then
		reporter.NoArgs()
	elseif args[1]=='toggle' then
		reporter.ArgToggle()
	elseif args[1]=='on' then 
		pluginState = 1
		print('reporter ON')
	elseif args[1]=='off' then 
		pluginState = 0
		print('reporter OFF')
	elseif args[1]=='group' then
		reporter.GroupModeToggle()
	else 
	print('Not a valid argument')
	end
end

function reporter.Init:OnEvent(event)
	pluginState = 1
	disablechatgroup = false
end

function reporter.GroupModeToggle()
	if (disablechatgroup == false) then
		disablechatgroup = true
		print('Group Mode active: No kills will be reported while in a group')
	else
		disablechatgroup = false
		print('Group Mode inactive: Kills will be reported even while in group')
	end
end

function reporter.GroupEvents:OnEvent(eventname, args)
	if eventname=='GROUP_CREATED' or eventname =='GROUP_SELF_JOINED' then
		if disablechatgroup == true then
			pluginState = 0
			print('reporter Autotoggled to OFF (group joined)')
		end
	elseif eventname=='GROUP_SELF_LEFT' then
		if disablechatgroup == true then
			pluginState = 1
			print('reporter Auto-toggled to ON (group left)')
		end
	end
end

function reporter.someDeath:OnEvent(event, deadguyID, killerID)
	if pluginState == 1 then
		if (not GetPlayerName(deadguyID):match("^%*")) then
			if (not GetPlayerName(killerID):match("^%*")) then
				if (deadguyID == killerID) then
					local deadguy = GetPlayerName(deadguyID) or "none"
					SendChat(deadguy .. " managed to suicide with style" , "GUILD")					
				else
				local deadguy = GetPlayerName(deadguyID) or "none"
				local killer = GetPlayerName(killerID) or "none"
				SendChat(deadguy .. " was destroyed by " .. killer, "GUILD")
				end
			end
		end
	end
end

RegisterEvent(reporter.someDeath, "PLAYER_DIED")
RegisterEvent(reporter.Init, "PLAYER_ENTERED_GAME")
RegisterEvent(reporter.GroupEvents, "GROUP_CREATED")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_LEFT")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_JOINED")

RegisterUserCommand('reporter', reporter.toggle)

-- for the anti-spam omit just store the messages in a table with table.insert(), then create a Timer() object and use :SetTimeout() to extract them.